// DSeqPict.cpp
// d.g.gilbert, 1991-95


#include <ncbi.h>
#include <dgg.h>
#include <Dvibrant.h>
#include <DWindow.h>
#include <DApplication.h>
#include <DRichViewNu.h>
#include <DPICTHandler.h>
#include <DGIFHandler.h>

#include "DSeqPict.h"

#ifdef WIN_MSWIN
#ifdef COMP_SYMC
typedef unsigned  char codechar;
#else
typedef FAR unsigned char  codechar;
#endif
#else
typedef unsigned char  codechar;
#endif

void CodePicture( DWindow* aDoc, char* data, ulong datalen, short pixwidth, short pixheight,
								  DRichView* itsView)
{
	char* cbeg= data;
	char* cend= cbeg + datalen;
	Boolean endOfData = true;
	ulong  dataRemaining;
	short  aFormat;
	
	if (!itsView) itsView= new DRichView( 0, aDoc, pixwidth, pixheight);
	itsView->SetSlateBorder(false);
	itsView->SetAutoAdjust(false); 
	DTempFile* aFile= new DTempFile();

	dataRemaining= datalen;
	DPICTHandler picthandler( itsView, aFile);
	if ( picthandler.ProcessData( cbeg, cend, endOfData, dataRemaining) )
		aFormat= picthandler.Format();
	else { 
		dataRemaining= datalen;
	  DGIFHandler gifhandler( itsView, aFile);
	  if ( gifhandler.ProcessData( cbeg, cend, endOfData, dataRemaining) ) 
	  	aFormat= gifhandler.Format(); 
	  else {
			dataRemaining= datalen;
		  DRichHandler texthandler( itsView, aFile);
		  if ( texthandler.ProcessData( cbeg, cend, endOfData, dataRemaining) ) 
		  	aFormat= texthandler.Format(); 
		  }
		 }
			  
	delete aFile;
}


class NucCodesPict {
public:
	enum { kLength = 3814, kWidth = 318, kHeight = 113 }; 
	static codechar data[kLength];
	NucCodesPict() {}
	static void show()
	{
		DRichView* aview= NULL;
		DWindow * aDoc= new DWindow( kNucCodesID, gApplication, DWindow::fixed);
		CodePicture( aDoc, (char*)data, kLength, kWidth + 24, kHeight + 12, aview);
		//aview->SizeToSuperview( aDoc, true, true);  
		aDoc->SetTitle("Nucleic Codes");
		aDoc->Open();
	}
};


class AminoCodesPict {
public:
	enum { kLength = 2076, kWidth = 233, kHeight = 172 }; 
	static codechar data[kLength];
	AminoCodesPict() {}
	static void show()
	{
		DRichView* aview= NULL;
		DWindow * aDoc= new DWindow( kAminoCodesID, gApplication, DWindow::fixed);
		CodePicture( aDoc, (char*) data, kLength, kWidth + 24, kHeight + 12, aview);
		//aview->SizeToSuperview( aDoc, true, true);  
		aDoc->SetTitle("Amino Codes");
		aDoc->Open();
	}
};



void NucCodesPicture()
{
	NucCodesPict::show();
}

void AminoCodesPicture()
{
	AminoCodesPict::show();
}




//PICT(1001) SeqApp.rsrc
//char* data[3814] =  
codechar NucCodesPict::data[NucCodesPict::kLength] = {
0x0e,0xe6,0x00,0x2a,0x00,0x0b,0x00,0x9b,0x01,0x49,0x00,0x11,0x02,0xff,0x0c,0x00,0xff,0xff,0xff,0xff,
0x00,0x0b,0x00,0x00,0x00,0x2a,0x00,0x00,0x01,0x49,0x00,0x00,0x00,0x9b,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0xa0,0x00,0x82,0x00,0xa0,0x00,0x8c,0x00,0xa1,0x00,0x64,0x00,0x30,0x64,0x72,0x77,0x32,0x00,0x04,
0x00,0x2b,0x00,0x0c,0x00,0x9a,0x01,0x48,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x02,0x00,0x00,
0x00,0x00,0x99,0x99,0xcc,0xcc,0xcc,0xcc,0xdd,0xdd,0xdd,0xdd,0xdd,0xdd,0xff,0x02,0x14,0x01,0x08,0x02,
0x00,0x00,0x00,0x1e,0x00,0x1a,0x99,0x99,0xcc,0xcc,0xcc,0xcc,0x00,0x1b,0xdd,0xdd,0xdd,0xdd,0xdd,0xdd,
0x00,0x01,0x00,0x0a,0x00,0x2a,0x00,0x0b,0x00,0x9b,0x01,0x49,0x00,0x09,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x31,0x00,0x2a,0x00,0x0b,0x00,0x9b,0x01,0x49,0x00,0x07,0x00,0x02,0x00,0x02,0x00,0x09,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x38,0x00,0xa1,0x00,0x64,0x00,0x30,0x64,0x72,0x77,0x32,
0x00,0x04,0x00,0x2e,0x00,0x0f,0x00,0x48,0x01,0x43,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x01,
0x00,0x00,0x00,0x00,0x00,0x00,0xaa,0xaa,0x00,0x00,0xcc,0xcc,0xff,0xff,0xcc,0xcc,0xff,0x02,0x14,0x01,
0x08,0x02,0x00,0x00,0x00,0x1a,0x00,0x00,0xaa,0xaa,0x00,0x00,0x00,0x1b,0xcc,0xcc,0xff,0xff,0xcc,0xcc,
0x00,0x09,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x31,0x00,0x2e,0x00,0x0f,0x00,0x49,0x01,0x44,
0x00,0x07,0x00,0x01,0x00,0x01,0x00,0x09,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x38,0x00,0xa0,
0x00,0x8c,0x00,0xa1,0x00,0x64,0x00,0x31,0x64,0x72,0x77,0x32,0x00,0x02,0x00,0x4e,0x00,0x84,0x00,0x96,
0x00,0x91,0x00,0x00,0x80,0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x99,0x99,0x00,0x00,
0x33,0x33,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x1b,0x00,0x01,0x01,0x02,0x00,0x00,0x01,0x00,0x00,0x1a,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1b,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x07,0x00,0x00,0x00,0x00,
0x00,0x30,0x00,0x4e,0x00,0x84,0x00,0x96,0x00,0x91,0x00,0xa1,0x00,0x96,0x00,0x06,0x02,0x00,0x00,0x00,
0x01,0x00,0x00,0xa1,0x00,0x9a,0x00,0x08,0x00,0x1a,0x00,0x00,0x00,0x04,0x00,0x00,0x00,0xa0,0x00,0x98,
0x00,0x1a,0x99,0x99,0x00,0x00,0x33,0x33,0x00,0x2c,0x00,0x09,0x00,0x03,0x06,0x47,0x65,0x6e,0x65,0x76,
0x61,0x00,0x00,0x03,0x00,0x03,0x00,0x04,0x01,0x00,0x00,0x0d,0x00,0x09,0x00,0x2e,0x00,0x04,0x00,0x00,
0x01,0x00,0x00,0x10,0x00,0x49,0x00,0x17,0x00,0x49,0x00,0x17,0x00,0x2b,0x87,0x58,0x02,0x52,0x0d,0x00,
0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x02,0x59,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,
0x00,0x98,0x00,0x28,0x00,0x70,0x00,0x86,0x02,0x4d,0x0d,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,
0x00,0x2b,0x01,0x0c,0x02,0x4b,0x0d,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x02,
0x53,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x28,0x00,0x94,0x00,0x86,0x02,0x57,0x0d,0x00,
0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x97,0x00,0xa1,0x00,0x64,0x00,0x31,0x64,0x72,0x77,0x32,0x00,0x02,
0x00,0x4e,0x00,0x9c,0x00,0x96,0x00,0xaf,0x00,0x00,0x80,0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x1b,0x00,0x01,0x01,0x02,
0x00,0x00,0x01,0x00,0x00,0x1a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x4e,0x00,0x9c,0x00,0x96,
0x00,0xaf,0x00,0xa1,0x00,0x96,0x00,0x06,0x02,0x00,0x00,0x00,0x01,0x00,0x00,0xa1,0x00,0x9a,0x00,0x08,
0x00,0x1a,0x00,0x00,0x00,0x09,0x00,0x00,0x00,0xa0,0x00,0x98,0x00,0x04,0x00,0x00,0x00,0x10,0x00,0x49,
0x00,0x1d,0x00,0x49,0x00,0x1d,0x00,0x28,0x00,0x58,0x00,0x9d,0x04,0x41,0x2c,0x47,0x0d,0x00,0x00,0xa0,
0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2b,0x01,0x0c,0x04,0x43,0x2c,0x54,0x0d,0x00,0x00,0xa0,0x00,0x99,
0x00,0xa0,0x00,0x98,0x00,0x28,0x00,0x70,0x00,0x9d,0x04,0x41,0x2c,0x43,0x0d,0x00,0x00,0xa0,0x00,0x99,
0x00,0xa0,0x00,0x98,0x00,0x2b,0x01,0x0c,0x04,0x47,0x2c,0x54,0x0d,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,
0x00,0x98,0x00,0x2a,0x0c,0x04,0x47,0x2c,0x43,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x28,
0x00,0x94,0x00,0x9d,0x04,0x41,0x2c,0x54,0x0d,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x97,0x00,0xa1,
0x00,0x64,0x00,0x31,0x64,0x72,0x77,0x32,0x00,0x02,0x00,0x4e,0x00,0xba,0x00,0x96,0x00,0xc6,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x77,0x77,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0x1b,0x00,0x01,0x01,0x02,0x00,0x00,0x01,0x00,0x00,0x1a,0x00,0x00,0x00,0x00,
0x77,0x77,0x00,0x30,0x00,0x4e,0x00,0xba,0x00,0x96,0x00,0xc6,0x00,0xa1,0x00,0x96,0x00,0x06,0x02,0x00,
0x00,0x00,0x01,0x0d,0x00,0xa1,0x00,0x9a,0x00,0x08,0x00,0x1a,0x00,0x00,0x00,0x03,0x00,0x00,0x00,0xa0,
0x00,0x98,0x00,0x10,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x28,0x00,0x58,0x00,0xbd,0x02,0x59,
0x0d,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x02,0x52,0x0d,0x00,0xa0,0x00,0x99,
0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x02,0x4b,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x28,
0x00,0x7c,0x00,0xbc,0x02,0x4d,0x0d,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x02,
0x57,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2b,0x01,0x0c,0x01,0x53,0x00,0xa0,0x00,0x99,
0x00,0xa0,0x00,0x97,0x00,0xa0,0x00,0x8d,0x00,0xa0,0x00,0x8c,0x00,0xa1,0x00,0x64,0x00,0x31,0x64,0x72,
0x77,0x32,0x00,0x02,0x00,0x3c,0x00,0x7c,0x00,0x48,0x00,0x93,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x1b,
0x00,0x01,0x01,0x02,0x00,0x00,0x01,0x00,0x00,0x1a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x3c,
0x00,0x7c,0x00,0x48,0x00,0x93,0x00,0xa1,0x00,0x96,0x00,0x06,0x01,0x00,0x00,0x00,0x01,0x0d,0x00,0xa1,
0x00,0x9a,0x00,0x08,0xff,0xfd,0x00,0x00,0x00,0x0a,0x80,0x00,0x00,0xa0,0x00,0x98,0x00,0x2c,0x00,0x08,
0x00,0x14,0x05,0x54,0x69,0x6d,0x65,0x73,0x00,0x03,0x00,0x14,0x00,0x04,0x02,0x00,0x00,0x0d,0x00,0x0a,
0x00,0x28,0x00,0x45,0x00,0x7d,0x04,0x43,0x6f,0x64,0x65,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x97,
0x00,0xa1,0x00,0x64,0x00,0x31,0x64,0x72,0x77,0x32,0x00,0x02,0x00,0x3c,0x00,0x97,0x00,0x48,0x00,0xb0,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x1b,0x00,0x01,0x01,0x02,0x00,0x00,0x01,0x00,0x00,0x30,0x00,0x3c,
0x00,0x97,0x00,0x48,0x00,0xb0,0x00,0xa1,0x00,0x96,0x00,0x06,0x02,0x00,0x00,0x00,0x01,0x0d,0x00,0xa1,
0x00,0x9a,0x00,0x08,0xff,0xfd,0x00,0x00,0x00,0x0b,0x80,0x00,0x00,0xa0,0x00,0x98,0x00,0x29,0x1b,0x05,
0x42,0x61,0x73,0x65,0x73,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x97,0x00,0xa1,0x00,0x64,0x00,0x31,
0x64,0x72,0x77,0x32,0x00,0x02,0x00,0x30,0x00,0xad,0x00,0x48,0x00,0xd1,0x00,0x00,0x80,0x00,0x00,0x00,
0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0x1b,0x00,0x01,0x01,0x02,0x00,0x00,0x01,0x00,0x00,0x30,0x00,0x30,0x00,0xad,0x00,0x48,0x00,0xd1,
0x00,0xa1,0x00,0x96,0x00,0x06,0x02,0x00,0x00,0x00,0x01,0x00,0x00,0xa1,0x00,0x9a,0x00,0x08,0x00,0x03,
0x00,0x00,0x00,0x11,0x80,0x00,0x00,0xa0,0x00,0x98,0x00,0x10,0x00,0x19,0x00,0x2e,0x00,0x19,0x00,0x2e,
0x00,0x28,0x00,0x39,0x00,0xae,0x08,0x43,0x6f,0x6d,0x70,0x6c,0x65,0x2d,0x0d,0x00,0x00,0xa0,0x00,0x99,
0x00,0xa0,0x00,0x98,0x00,0x2b,0x08,0x0c,0x04,0x6d,0x65,0x6e,0x74,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,
0x00,0x97,0x00,0xa0,0x00,0x8d,0x00,0xa0,0x00,0x8c,0x00,0xa1,0x00,0x64,0x00,0x31,0x64,0x72,0x77,0x32,
0x00,0x02,0x00,0x4e,0x00,0x40,0x00,0x8a,0x00,0x4d,0x00,0x00,0x80,0x00,0x00,0x00,0x80,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x99,0x99,0x00,0x00,0x33,0x33,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x1b,0x00,0x01,
0x01,0x02,0x00,0x00,0x01,0x00,0x00,0x01,0x00,0x0a,0x00,0x2a,0x00,0x0b,0x00,0x9b,0x01,0x1f,0x00,0x30,
0x00,0x4e,0x00,0x40,0x00,0x8a,0x00,0x4d,0x00,0xa1,0x00,0x96,0x00,0x06,0x01,0x00,0x00,0x00,0x01,0x00,
0x00,0xa1,0x00,0x9a,0x00,0x08,0x00,0x14,0x00,0x00,0x00,0x06,0x00,0x00,0x00,0xa0,0x00,0x98,0x00,0x1a,
0x99,0x99,0x00,0x00,0x33,0x33,0x00,0x03,0x00,0x03,0x00,0x04,0x01,0x00,0x00,0x0d,0x00,0x09,0x00,0x10,
0x00,0x3d,0x00,0x17,0x00,0x3d,0x00,0x17,0x00,0x28,0x00,0x58,0x00,0x41,0x02,0x41,0x0d,0x00,0x00,0xa0,
0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x02,0x43,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,
0x00,0x2a,0x0c,0x02,0x47,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x02,0x54,0x0d,
0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x02,0x55,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,
0x00,0x97,0x00,0xa1,0x00,0x64,0x00,0x31,0x64,0x72,0x77,0x32,0x00,0x02,0x00,0x4e,0x00,0x57,0x00,0x8a,
0x00,0x63,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x77,0x77,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x1b,0x00,0x01,0x01,0x02,0x00,0x00,0x01,0x00,0x00,0x1a,
0x00,0x00,0x00,0x00,0x77,0x77,0x00,0x01,0x00,0x0a,0x00,0x2a,0x00,0x0b,0x00,0x9b,0x01,0x49,0x00,0x30,
0x00,0x4e,0x00,0x57,0x00,0x8a,0x00,0x63,0x00,0xa1,0x00,0x96,0x00,0x06,0x01,0x00,0x00,0x00,0x01,0x0d,
0x00,0xa1,0x00,0x9a,0x00,0x08,0x00,0x14,0x00,0x00,0x00,0x05,0x00,0x00,0x00,0xa0,0x00,0x98,0x00,0x04,
0x00,0x00,0x00,0x10,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x28,0x00,0x58,0x00,0x58,0x02,0x54,
0x0d,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x02,0x47,0x0d,0x00,0xa0,0x00,0x99,
0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x02,0x43,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,
0x0c,0x02,0x41,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x01,0x41,0x00,0x00,0xa0,
0x00,0x99,0x00,0xa0,0x00,0x97,0x00,0xa1,0x00,0x64,0x00,0x31,0x64,0x72,0x77,0x32,0x00,0x02,0x00,0x4e,
0x00,0x14,0x00,0x8a,0x00,0x3a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x1b,0x00,0x01,0x01,0x02,0x00,0x00,
0x01,0x00,0x00,0x1a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x4e,0x00,0x14,0x00,0x8a,0x00,0x3a,
0x00,0xa1,0x00,0x96,0x00,0x06,0x01,0x00,0x00,0x00,0x01,0x0d,0x00,0xa1,0x00,0x9a,0x00,0x08,0x00,0x15,
0x00,0x00,0x00,0x12,0x00,0x00,0x00,0xa0,0x00,0x98,0x00,0x03,0x00,0x14,0x00,0x0d,0x00,0x0a,0x00,0x28,
0x00,0x57,0x00,0x15,0x08,0x41,0x64,0x65,0x6e,0x69,0x6e,0x65,0x0d,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,
0x00,0x98,0x00,0x2a,0x0c,0x09,0x43,0x79,0x74,0x6f,0x73,0x69,0x6e,0x65,0x0d,0x00,0x00,0xa0,0x00,0x99,
0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x08,0x47,0x75,0x61,0x6e,0x69,0x6e,0x65,0x0d,0x00,0xa0,0x00,0x99,
0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x08,0x54,0x68,0x79,0x6d,0x69,0x6e,0x65,0x0d,0x00,0xa0,0x00,0x99,
0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x06,0x55,0x72,0x61,0x63,0x69,0x6c,0x00,0xa0,0x00,0x99,0x00,0xa0,
0x00,0x97,0x00,0xa0,0x00,0x8d,0x00,0xa0,0x00,0x8c,0x00,0xa1,0x00,0x64,0x00,0x31,0x64,0x72,0x77,0x32,
0x00,0x02,0x00,0x3c,0x00,0x17,0x00,0x48,0x00,0x2d,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x01,0x02,0x00,0x00,
0x01,0x02,0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x3c,0x00,0x17,0x00,0x48,0x00,0x2d,0x00,0xa1,0x00,0x96,
0x00,0x06,0x01,0x00,0x00,0x00,0x01,0x0d,0x00,0xa1,0x00,0x9a,0x00,0x08,0xff,0xfd,0x00,0x00,0x00,0x0a,
0x00,0x00,0x00,0xa0,0x00,0x98,0x00,0x04,0x02,0x00,0x00,0x28,0x00,0x45,0x00,0x18,0x04,0x42,0x61,0x73,
0x65,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x97,0x00,0xa1,0x00,0x64,0x00,0x31,0x64,0x72,0x77,0x32,
0x00,0x02,0x00,0x31,0x00,0x4e,0x00,0x49,0x00,0x72,0x00,0x00,0x80,0x00,0x00,0x00,0x80,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x01,0x02,0x00,0x00,
0x01,0x02,0x00,0x00,0x01,0x00,0x00,0x01,0x00,0x0a,0x00,0x2a,0x00,0x0b,0x00,0x9b,0x01,0x44,0x00,0x30,
0x00,0x31,0x00,0x4e,0x00,0x49,0x00,0x72,0x00,0xa1,0x00,0x96,0x00,0x06,0x02,0x00,0x00,0x00,0x01,0x00,
0x00,0xa1,0x00,0x9a,0x00,0x08,0x00,0x03,0x00,0x00,0x00,0x11,0x80,0x00,0x00,0xa0,0x00,0x98,0x00,0x10,
0x00,0x19,0x00,0x2e,0x00,0x19,0x00,0x2e,0x00,0x28,0x00,0x3a,0x00,0x4f,0x08,0x43,0x6f,0x6d,0x70,0x6c,
0x65,0x2d,0x0d,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2b,0x08,0x0c,0x04,0x6d,0x65,0x6e,
0x74,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x97,0x00,0xa1,0x00,0x64,0x00,0x31,0x64,0x72,0x77,0x32,
0x00,0x02,0x00,0x3c,0x00,0x39,0x00,0x48,0x00,0x50,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x01,0x02,0x00,0x00,
0x01,0x02,0x00,0x00,0x01,0x00,0x00,0x01,0x00,0x0a,0x00,0x2a,0x00,0x0b,0x00,0x9b,0x01,0x49,0x00,0x30,
0x00,0x3c,0x00,0x39,0x00,0x48,0x00,0x50,0x00,0xa1,0x00,0x96,0x00,0x06,0x01,0x00,0x00,0x00,0x01,0x0d,
0x00,0xa1,0x00,0x9a,0x00,0x08,0xff,0xfd,0x00,0x00,0x00,0x0a,0x80,0x00,0x00,0xa0,0x00,0x98,0x00,0x10,
0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x28,0x00,0x45,0x00,0x3a,0x04,0x43,0x6f,0x64,0x65,0x00,
0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x97,0x00,0xa0,0x00,0x8d,0x00,0xa0,0x00,0x8c,0x00,0xa1,0x00,0x64,
0x00,0x31,0x64,0x72,0x77,0x32,0x00,0x02,0x00,0x4e,0x00,0xe1,0x00,0x8a,0x00,0xf5,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x99,0x99,0x00,0x00,0x33,0x33,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0x1b,0x00,0x01,0x01,0x02,0x00,0x00,0x01,0x00,0x00,0x1a,0x99,0x99,0x00,0x00,0x33,0x33,
0x00,0x30,0x00,0x4e,0x00,0xe1,0x00,0x8a,0x00,0xf5,0x00,0xa1,0x00,0x96,0x00,0x06,0x02,0x00,0x00,0x00,
0x01,0x0d,0x00,0xa1,0x00,0x9a,0x00,0x08,0x00,0x14,0x00,0x00,0x00,0x03,0x00,0x00,0x00,0xa0,0x00,0x98,
0x00,0x03,0x00,0x03,0x00,0x04,0x01,0x00,0x00,0x0d,0x00,0x09,0x00,0x2b,0xae,0x13,0x02,0x48,0x0d,0x00,
0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x02,0x42,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,
0x00,0x98,0x00,0x2a,0x0c,0x02,0x56,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x02,
0x44,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x28,0x00,0x88,0x00,0xe2,0x03,0x4e,0x2c,0x2d,
0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x97,0x00,0xa1,0x00,0x64,0x00,0x31,0x64,0x72,0x77,0x32,0x00,0x02,
0x00,0x4e,0x00,0xfa,0x00,0x8a,0x01,0x21,0x00,0x00,0x80,0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x1b,0x00,0x01,0x01,0x02,
0x00,0x00,0x01,0x00,0x00,0x1a,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x00,0x0a,0x00,0x2a,0x00,0x32,
0x00,0x9b,0x01,0x49,0x00,0x30,0x00,0x4e,0x00,0xfa,0x00,0x8a,0x01,0x21,0x00,0xa1,0x00,0x96,0x00,0x06,
0x02,0x00,0x00,0x00,0x01,0x00,0x00,0xa1,0x00,0x9a,0x00,0x08,0x00,0x14,0x00,0x00,0x00,0x0e,0x00,0x00,
0x00,0xa0,0x00,0x98,0x00,0x04,0x00,0x00,0x00,0x10,0x00,0x3d,0x00,0x31,0x00,0x3d,0x00,0x31,0x00,0x28,
0x00,0x58,0x01,0x00,0x06,0x41,0x2c,0x54,0x2c,0x43,0x0d,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,
0x00,0x2b,0x01,0x0c,0x06,0x47,0x2c,0x54,0x2c,0x43,0x0d,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,
0x00,0x28,0x00,0x70,0x01,0x00,0x06,0x47,0x2c,0x41,0x2c,0x43,0x0d,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,
0x00,0x98,0x00,0x2a,0x0c,0x06,0x47,0x2c,0x41,0x2c,0x54,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,
0x00,0x28,0x00,0x88,0x00,0xfb,0x07,0x47,0x2c,0x41,0x2c,0x54,0x2c,0x43,0x00,0xa0,0x00,0x99,0x00,0xa0,
0x00,0x97,0x00,0xa1,0x00,0x64,0x00,0x31,0x64,0x72,0x77,0x32,0x00,0x02,0x00,0x4e,0x01,0x29,0x00,0x8a,
0x01,0x3a,0x00,0x00,0x80,0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x99,0x99,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x1b,0x00,0x01,0x01,0x02,0x00,0x00,0x01,0x00,0x00,0x01,
0x00,0x0a,0x00,0x2a,0x00,0x61,0x00,0x9b,0x01,0x49,0x00,0x30,0x00,0x4e,0x01,0x29,0x00,0x8a,0x01,0x3a,
0x00,0xa1,0x00,0x96,0x00,0x06,0x02,0x00,0x00,0x00,0x01,0x00,0x00,0xa1,0x00,0x9a,0x00,0x08,0x00,0x14,
0x00,0x00,0x00,0x03,0x00,0x00,0x00,0xa0,0x00,0x98,0x00,0x1a,0x00,0x00,0x00,0x00,0x99,0x99,0x00,0x10,
0x00,0x3d,0x00,0x1b,0x00,0x3d,0x00,0x1b,0x00,0x28,0x00,0x58,0x01,0x2f,0x02,0x44,0x0d,0x00,0x00,0xa0,
0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x02,0x56,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,
0x00,0x2a,0x0c,0x02,0x42,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x02,0x48,0x0d,
0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x28,0x00,0x88,0x01,0x2a,0x04,0x4e,0x2c,0x2d,0x0d,0x00,
0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x97,0x00,0xa0,0x00,0x8d,0x00,0xa1,0x00,0x64,0x00,0x60,0x64,0x72,
0x77,0x32,0x00,0x03,0x00,0x4e,0x00,0x72,0x00,0x8b,0x00,0x72,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x01,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x02,
0x1a,0x1a,0x08,0x02,0x00,0x00,0x00,0x00,0x00,0x8b,0x00,0x72,0x00,0x4e,0x00,0x72,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x01,0x00,0x14,0x00,0x0c,0x00,0x03,0x00,0x02,0x00,0x00,0x00,0x5a,0x00,0x01,
0x00,0x00,0x00,0x02,0x00,0x00,0x00,0x16,0x00,0x0a,0x00,0x00,0x00,0x00,0x00,0x1a,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x01,0x00,0x0a,0x00,0x2a,0x00,0x0b,0x00,0x9b,0x01,0x49,0x00,0x07,0x00,0x01,0x00,0x01,
0x00,0x09,0x00,0xff,0x00,0xff,0x00,0xff,0x00,0xff,0x00,0x22,0x00,0x8b,0x00,0x72,0x00,0xc3,0x00,0xa1,
0x00,0x64,0x00,0x60,0x64,0x72,0x77,0x32,0x00,0x03,0x00,0x4e,0x00,0xd6,0x00,0x8b,0x00,0xd6,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0x02,0x1a,0x1a,0x08,0x02,0x00,0x00,0x00,0x00,0x00,0x8b,0x00,0xd6,0x00,0x4e,
0x00,0xd6,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x00,0x14,0x00,0x0c,0x00,0x03,0x00,0x02,
0x00,0x00,0x00,0x5a,0x00,0x01,0x00,0x00,0x00,0x02,0x00,0x00,0x00,0x16,0x00,0x0a,0x00,0x00,0x00,0x00,
0x00,0x22,0x00,0x8b,0x00,0xd6,0x00,0xc3,0x00,0xa0,0x00,0x8c,0x00,0xa1,0x00,0x64,0x00,0x31,0x64,0x72,
0x77,0x32,0x00,0x02,0x00,0x3d,0x00,0xe0,0x00,0x49,0x00,0xf7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x1b,
0x00,0x01,0x01,0x02,0x00,0x00,0x01,0x00,0x00,0x07,0x00,0x00,0x00,0x00,0x00,0x09,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0x00,0x30,0x00,0x3d,0x00,0xe0,0x00,0x49,0x00,0xf7,0x00,0xa1,0x00,0x96,0x00,0x06,
0x01,0x00,0x00,0x00,0x01,0x0d,0x00,0xa1,0x00,0x9a,0x00,0x08,0xff,0xfd,0x00,0x00,0x00,0x0a,0x80,0x00,
0x00,0xa0,0x00,0x98,0x00,0x03,0x00,0x14,0x00,0x04,0x02,0x00,0x00,0x0d,0x00,0x0a,0x00,0x10,0x00,0x01,
0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x28,0x00,0x46,0x00,0xe1,0x04,0x43,0x6f,0x64,0x65,0x00,0x00,0xa0,
0x00,0x99,0x00,0xa0,0x00,0x97,0x00,0xa1,0x00,0x64,0x00,0x31,0x64,0x72,0x77,0x32,0x00,0x02,0x00,0x3d,
0x00,0xfe,0x00,0x49,0x01,0x17,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x1b,0x00,0x01,0x01,0x02,0x00,0x00,
0x01,0x00,0x00,0x30,0x00,0x3d,0x00,0xfe,0x00,0x49,0x01,0x17,0x00,0xa1,0x00,0x96,0x00,0x06,0x02,0x00,
0x00,0x00,0x01,0x0d,0x00,0xa1,0x00,0x9a,0x00,0x08,0xff,0xfd,0x00,0x00,0x00,0x0b,0x80,0x00,0x00,0xa0,
0x00,0x98,0x00,0x29,0x1e,0x05,0x42,0x61,0x73,0x65,0x73,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x97,
0x00,0xa1,0x00,0x64,0x00,0x31,0x64,0x72,0x77,0x32,0x00,0x02,0x00,0x31,0x01,0x16,0x00,0x49,0x01,0x3a,
0x00,0x00,0x80,0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x1b,0x00,0x01,0x01,0x02,0x00,0x00,0x01,0x00,0x00,0x01,0x00,0x0a,
0x00,0x2a,0x00,0x4e,0x00,0x9b,0x01,0x49,0x00,0x30,0x00,0x31,0x01,0x16,0x00,0x49,0x01,0x3a,0x00,0xa1,
0x00,0x96,0x00,0x06,0x02,0x00,0x00,0x00,0x01,0x00,0x00,0xa1,0x00,0x9a,0x00,0x08,0x00,0x03,0x00,0x00,
0x00,0x11,0x80,0x00,0x00,0xa0,0x00,0x98,0x00,0x10,0x00,0x19,0x00,0x2e,0x00,0x19,0x00,0x2e,0x00,0x28,
0x00,0x3a,0x01,0x17,0x08,0x43,0x6f,0x6d,0x70,0x6c,0x65,0x2d,0x0d,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,
0x00,0x98,0x00,0x2b,0x08,0x0c,0x04,0x6d,0x65,0x6e,0x74,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x97,
0x00,0xa0,0x00,0x8d,0x00,0xa0,0x00,0x8d,0x00,0xa0,0x00,0x83,0x00,0xff
};


codechar AminoCodesPict::data[AminoCodesPict::kLength] = {
//PICT(1002) SeqApp.rsrc
//char* data[2076] = { 
0x08,0x1c,0x00,0x1e,0x01,0x56,0x00,0xca,0x02,0x3f,0x00,0x11,0x02,0xff,0x0c,0x00,0xff,0xff,0xff,0xff,
0x01,0x56,0x00,0x00,0x00,0x1e,0x00,0x00,0x02,0x3f,0x00,0x00,0x00,0xca,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0xa0,0x00,0x82,0x00,0xa0,0x00,0x8c,0x00,0xa1,0x00,0x64,0x00,0x30,0x64,0x72,0x77,0x32,0x00,0x04,
0x00,0x1f,0x01,0x57,0x00,0xc9,0x02,0x3e,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x02,0x00,0x00,
0x00,0x00,0x99,0x99,0xcc,0xcc,0x99,0x99,0xcc,0xcc,0xff,0xff,0xff,0xff,0xff,0x02,0x14,0x01,0x08,0x02,
0x00,0x00,0x00,0x1e,0x00,0x1a,0x99,0x99,0xcc,0xcc,0x99,0x99,0x00,0x1b,0xcc,0xcc,0xff,0xff,0xff,0xff,
0x00,0x01,0x00,0x0a,0x00,0x1e,0x01,0x56,0x00,0xca,0x02,0x3f,0x00,0x09,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x31,0x00,0x1e,0x01,0x56,0x00,0xca,0x02,0x3f,0x00,0x07,0x00,0x02,0x00,0x02,0x00,0x09,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x38,0x00,0xa0,0x00,0x8c,0x00,0xa0,0x00,0x8c,0x00,0xa1,
0x00,0x64,0x00,0x31,0x64,0x72,0x77,0x32,0x00,0x02,0x00,0x25,0x01,0x68,0x00,0x9d,0x01,0xc2,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0x0b,0x00,0x01,0x01,0x02,0x00,0x00,0x01,0x00,0x00,0x1a,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x1b,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x07,0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x25,
0x01,0x68,0x00,0x9d,0x01,0xc2,0x00,0xa1,0x00,0x96,0x00,0x06,0x01,0x00,0x00,0x00,0x01,0x0d,0x00,0xa1,
0x00,0x9a,0x00,0x08,0x00,0x32,0x00,0x00,0x00,0x2c,0x00,0x00,0x00,0xa0,0x00,0x98,0x00,0x2c,0x00,0x09,
0x00,0x03,0x06,0x47,0x65,0x6e,0x65,0x76,0x61,0x00,0x00,0x03,0x00,0x03,0x00,0x0d,0x00,0x09,0x00,0x2e,
0x00,0x04,0x00,0x00,0x01,0x00,0x00,0x28,0x00,0x2f,0x01,0x69,0x0e,0x41,0x6c,0x61,0x6e,0x69,0x6e,0x65,
0x20,0x28,0x41,0x6c,0x61,0x29,0x0d,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x0f,
0x41,0x72,0x67,0x69,0x6e,0x69,0x6e,0x65,0x20,0x28,0x41,0x72,0x67,0x29,0x0d,0x00,0x00,0xa0,0x00,0x99,
0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x11,0x41,0x73,0x70,0x61,0x72,0x61,0x67,0x69,0x6e,0x65,0x20,0x28,
0x41,0x73,0x6e,0x29,0x0d,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x14,0x41,0x73,
0x70,0x61,0x72,0x74,0x69,0x63,0x20,0x61,0x63,0x69,0x64,0x20,0x28,0x41,0x73,0x70,0x29,0x0d,0x00,0xa0,
0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x0f,0x43,0x79,0x73,0x74,0x65,0x69,0x6e,0x65,0x20,0x28,
0x43,0x79,0x73,0x29,0x0d,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x10,0x47,0x6c,
0x75,0x74,0x61,0x6d,0x69,0x6e,0x65,0x20,0x28,0x47,0x6c,0x6e,0x29,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,
0x00,0x98,0x00,0x2a,0x0c,0x14,0x47,0x6c,0x75,0x74,0x61,0x6d,0x69,0x63,0x20,0x61,0x63,0x69,0x64,0x20,
0x28,0x47,0x6c,0x75,0x29,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x0e,0x47,0x6c,
0x79,0x63,0x69,0x6e,0x65,0x20,0x28,0x47,0x6c,0x79,0x29,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,
0x00,0x2a,0x0c,0x10,0x48,0x69,0x73,0x74,0x69,0x64,0x69,0x6e,0x65,0x20,0x28,0x48,0x69,0x73,0x29,0x0d,
0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x10,0x49,0x73,0x6f,0x6c,0x65,0x75,0x63,0x69,
0x6e,0x65,0x20,0x28,0x49,0x6c,0x65,0x29,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x97,0x00,0xa1,0x00,0x64,
0x00,0x31,0x64,0x72,0x77,0x32,0x00,0x02,0x00,0x25,0x01,0x5c,0x00,0x9d,0x01,0x69,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x55,0x55,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0x0b,0x00,0x01,0x01,0x02,0x00,0x00,0x01,0x00,0x00,0x1a,0x55,0x55,0x00,0x00,0x00,0x00,
0x00,0x30,0x00,0x25,0x01,0x5c,0x00,0x9d,0x01,0x69,0x00,0xa1,0x00,0x96,0x00,0x06,0x01,0x00,0x00,0x00,
0x01,0x0d,0x00,0xa1,0x00,0x9a,0x00,0x08,0x00,0x32,0x00,0x00,0x00,0x05,0x80,0x00,0x00,0xa0,0x00,0x98,
0x00,0x04,0x01,0x00,0x00,0x28,0x00,0x2f,0x01,0x5d,0x02,0x41,0x0d,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,
0x00,0x98,0x00,0x2a,0x0c,0x02,0x52,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x02,
0x4e,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x02,0x44,0x0d,0x00,0xa0,0x00,0x99,
0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x02,0x43,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,
0x0c,0x02,0x51,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x02,0x45,0x0d,0x00,0xa0,
0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x02,0x47,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,
0x00,0x2a,0x0c,0x02,0x48,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x02,0x49,0x0d,
0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x97,0x00,0xa0,0x00,0x8d,0x00,0xa0,0x00,0x8c,0x00,0xa1,0x00,0x64,
0x00,0x31,0x64,0x72,0x77,0x32,0x00,0x02,0x00,0x25,0x01,0xda,0x00,0xa9,0x02,0x3b,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,
0xff,0xff,0x01,0x02,0x00,0x00,0x01,0x02,0x00,0x00,0x01,0x00,0x00,0x1a,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x30,0x00,0x25,0x01,0xda,0x00,0xa9,0x02,0x3b,0x00,0xa1,0x00,0x96,0x00,0x06,0x01,0x00,0x00,0x00,
0x01,0x0d,0x00,0xa1,0x00,0x9a,0x00,0x08,0x00,0x38,0x00,0x00,0x00,0x2f,0x80,0x00,0x00,0xa0,0x00,0x98,
0x00,0x04,0x00,0x00,0x00,0x28,0x00,0x2f,0x01,0xdb,0x0e,0x4c,0x65,0x75,0x63,0x69,0x6e,0x65,0x20,0x28,
0x4c,0x65,0x75,0x29,0x0d,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x0d,0x4c,0x79,
0x73,0x69,0x6e,0x65,0x20,0x28,0x4c,0x79,0x73,0x29,0x0d,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,
0x00,0x2a,0x0c,0x11,0x4d,0x65,0x74,0x68,0x69,0x6f,0x6e,0x69,0x6e,0x65,0x20,0x28,0x4d,0x65,0x74,0x29,
0x0d,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x14,0x50,0x68,0x65,0x6e,0x79,0x6c,
0x61,0x6c,0x61,0x6e,0x69,0x6e,0x65,0x20,0x28,0x50,0x68,0x65,0x29,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,
0x00,0x98,0x00,0x2a,0x0c,0x0e,0x50,0x72,0x6f,0x6c,0x69,0x6e,0x65,0x20,0x28,0x50,0x72,0x6f,0x29,0x0d,
0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x0d,0x53,0x65,0x72,0x69,0x6e,0x65,0x20,0x28,
0x53,0x65,0x72,0x29,0x0d,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x10,0x54,0x68,
0x72,0x65,0x6f,0x6e,0x69,0x6e,0x65,0x20,0x28,0x54,0x68,0x72,0x29,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,
0x00,0x98,0x00,0x2a,0x0c,0x11,0x54,0x72,0x79,0x70,0x74,0x6f,0x70,0x68,0x61,0x6e,0x20,0x28,0x54,0x72,
0x70,0x29,0x0d,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x0f,0x54,0x79,0x72,0x6f,
0x73,0x69,0x6e,0x65,0x20,0x28,0x54,0x79,0x72,0x29,0x0d,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,
0x00,0x2a,0x0c,0x0d,0x56,0x61,0x6c,0x69,0x6e,0x65,0x20,0x28,0x56,0x61,0x6c,0x29,0x0d,0x00,0x00,0xa0,
0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x15,0x41,0x6e,0x79,0x20,0x61,0x6d,0x69,0x6e,0x6f,0x20,
0x61,0x63,0x69,0x64,0x20,0x28,0x58,0x61,0x61,0x29,0x0d,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x97,
0x00,0xa1,0x00,0x64,0x00,0x31,0x64,0x72,0x77,0x32,0x00,0x02,0x00,0x25,0x01,0xce,0x00,0xa9,0x01,0xdb,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x55,0x55,0x00,0x00,0x00,0x00,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x0b,0x00,0x01,0x01,0x02,0x00,0x00,0x01,0x00,0x00,0x1a,0x55,0x55,
0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x25,0x01,0xce,0x00,0xa9,0x01,0xdb,0x00,0xa1,0x00,0x96,0x00,0x06,
0x01,0x00,0x00,0x00,0x01,0x0d,0x00,0xa1,0x00,0x9a,0x00,0x08,0x00,0x38,0x00,0x00,0x00,0x05,0x80,0x00,
0x00,0xa0,0x00,0x98,0x00,0x04,0x01,0x00,0x00,0x28,0x00,0x2f,0x01,0xcf,0x02,0x4c,0x0d,0x00,0x00,0xa0,
0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x02,0x4b,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,
0x00,0x2a,0x0c,0x02,0x4d,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x02,0x46,0x0d,
0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x02,0x50,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,
0x00,0x98,0x00,0x2a,0x0c,0x02,0x53,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x02,
0x54,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x02,0x57,0x0d,0x00,0xa0,0x00,0x99,
0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x02,0x59,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,
0x0c,0x02,0x56,0x0d,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x01,0x58,0x00,0x00,0xa0,
0x00,0x99,0x00,0xa0,0x00,0x97,0x00,0xa0,0x00,0x8d,0x00,0xa1,0x00,0x64,0x00,0x60,0x64,0x72,0x77,0x32,
0x00,0x03,0x00,0x25,0x01,0xc5,0x00,0xa3,0x01,0xc5,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x01,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x02,0x1a,0x1a,
0x08,0x02,0x00,0x00,0x00,0x00,0x00,0x25,0x01,0xc5,0x00,0xa3,0x01,0xc5,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x01,0x00,0x14,0x00,0x0c,0x00,0x03,0x00,0x02,0x00,0x00,0x00,0x5a,0x00,0x01,0x00,0x00,
0x00,0x02,0x00,0x00,0x00,0x16,0x00,0x0a,0x00,0x00,0x00,0x00,0x00,0x1a,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x07,0x00,0x01,0x00,0x01,0x00,0x09,0x00,0xff,0x00,0xff,0x00,0xff,0x00,0xff,0x00,0x22,0x00,0x25,
0x01,0xc5,0x00,0x7e,0x00,0xa0,0x00,0x8c,0x00,0xa1,0x00,0x64,0x00,0x31,0x64,0x72,0x77,0x32,0x00,0x02,
0x00,0xab,0x01,0x6f,0x00,0xc3,0x02,0x0c,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x0b,0x00,0x01,0x01,0x02,
0x00,0x00,0x01,0x00,0x00,0x07,0x00,0x00,0x00,0x00,0x00,0x09,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0x00,0x30,0x00,0xab,0x01,0x6f,0x00,0xc3,0x02,0x0c,0x00,0xa1,0x00,0x96,0x00,0x06,0x01,0x00,0x00,0x00,
0x01,0x0d,0x00,0xa1,0x00,0x9a,0x00,0x08,0x00,0x02,0x00,0x00,0x00,0x4d,0x80,0x00,0x00,0xa0,0x00,0x98,
0x00,0x04,0x00,0x00,0x00,0x28,0x00,0xb5,0x01,0x70,0x22,0x41,0x73,0x70,0x61,0x72,0x74,0x69,0x63,0x20,
0x61,0x63,0x69,0x64,0x20,0x6f,0x72,0x20,0x41,0x73,0x70,0x61,0x72,0x61,0x67,0x69,0x6e,0x65,0x20,0x28,
0x41,0x73,0x78,0x29,0x0d,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x20,0x47,0x6c,
0x75,0x74,0x61,0x6d,0x69,0x63,0x20,0x61,0x63,0x69,0x64,0x20,0x6f,0x72,0x20,0x47,0x6c,0x75,0x74,0x61,
0x6d,0x69,0x6e,0x65,0x20,0x28,0x47,0x6c,0x78,0x29,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x97,0x00,0xa1,
0x00,0x64,0x00,0x31,0x64,0x72,0x77,0x32,0x00,0x02,0x00,0xab,0x01,0x64,0x00,0xc3,0x01,0x71,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0x0b,0x00,0x01,0x01,0x02,0x00,0x00,0x01,0x00,0x00,0x30,0x00,0xab,0x01,0x64,
0x00,0xc3,0x01,0x71,0x00,0xa1,0x00,0x96,0x00,0x06,0x01,0x00,0x00,0x00,0x01,0x0d,0x00,0xa1,0x00,0x9a,
0x00,0x08,0x00,0x02,0x00,0x00,0x00,0x05,0x80,0x00,0x00,0xa0,0x00,0x98,0x00,0x1a,0x55,0x55,0x00,0x00,
0x00,0x00,0x00,0x04,0x01,0x00,0x00,0x28,0x00,0xb5,0x01,0x65,0x02,0x42,0x0d,0x00,0x00,0xa0,0x00,0x99,
0x00,0xa0,0x00,0x98,0x00,0x2a,0x0c,0x01,0x5a,0x00,0x00,0xa0,0x00,0x99,0x00,0xa0,0x00,0x97,0x00,0xa0,
0x00,0x8d,0x00,0xa0,0x00,0x8d,0x00,0xa0,0x00,0x8d,0x00,0xa0,0x00,0x83,0x00,0xff
};





